Index: EcnlProtoTool/trunk/prototool/src/apilist.c
===================================================================
--- EcnlProtoTool/trunk/prototool/src/apilist.c	(revision 439)
+++ EcnlProtoTool/trunk/prototool/src/apilist.c	(revision 439)
@@ -0,0 +1,240 @@
+/*
+ * apilist.c
+ */
+
+#include <ctype.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "mrdb.h"
+#include "mrdberror.h"
+#include "apilist.h"
+#include <mruby/compile.h>
+#include <mruby/irep.h>
+#include <mruby/debug.h>
+
+#define LINE_BUF_SIZE MAX_COMMAND_LINE
+
+typedef struct source_file {
+  char *path;
+  uint16_t lineno;
+  FILE *fp;
+} source_file;
+
+static void
+source_file_free(mrb_state *mrb, source_file *file)
+{
+  if (file != NULL) {
+    if (file->path != NULL) {
+      mrb_free(mrb, file->path);
+    }
+    if (file->fp != NULL) {
+      fclose(file->fp);
+      file->fp = NULL;
+    }
+    mrb_free(mrb, file);
+  }
+}
+
+static char*
+build_path(mrb_state *mrb, const char *dir, const char *base)
+{
+  int len;
+  char *path = NULL;
+
+  len = strlen(base) + 1;
+
+  if (strcmp(dir, ".")) {
+    len += strlen(dir) + sizeof("/") - 1;
+  }
+
+  path = (char*)mrb_malloc(mrb, len);
+  memset(path, 0, len);
+
+  if (strcmp(dir, ".")) {
+    strcat(path, dir);
+    strcat(path, "/");
+  }
+  strcat(path, base);
+
+  return path;
+}
+
+static char*
+dirname(mrb_state *mrb, const char *path)
+{
+  size_t len;
+  const char *p;
+  char *dir;
+
+  if (path == NULL) {
+    return NULL;
+  }
+
+  p = strrchr(path, '/');
+  len = p != NULL ? (size_t)(p - path) : strlen(path);
+
+  dir = (char*)mrb_malloc(mrb, len + 1);
+  strncpy(dir, path, len);
+  dir[len] = '\0';
+
+  return dir;
+}
+
+static source_file*
+source_file_new(mrb_state *mrb, mrb_debug_context *dbg, char *filename)
+{
+  source_file *file;
+
+  file = (source_file*)mrb_malloc(mrb, sizeof(source_file));
+
+  memset(file, '\0', sizeof(source_file));
+  file->fp = fopen(filename, "rb");
+
+  if (file->fp == NULL) {
+    source_file_free(mrb, file);
+    return NULL;
+  }
+
+  file->lineno = 1;
+  file->path = (char*)mrb_malloc(mrb, strlen(filename) + 1);
+  strcpy(file->path, filename);
+  return file;
+}
+
+static mrb_bool
+remove_newlines(char *s, FILE *fp)
+{
+  int c;
+  char *p;
+  size_t len;
+
+  if ((len = strlen(s)) == 0) {
+    return FALSE;
+  }
+
+  p = s + len - 1;
+
+  if (*p != '\r' && *p != '\n') {
+    return FALSE;
+  }
+
+  if (*p == '\r') {
+    /* peek the next character and skip '\n' */
+    if ((c = fgetc(fp)) != '\n') {
+      ungetc(c, fp);
+    }
+  }
+
+  /* remove trailing newline characters */
+  while (s <= p && (*p == '\r' || *p == '\n')) {
+    *p-- = '\0';
+  }
+
+  return TRUE;
+}
+
+static void
+show_lines(source_file *file, uint16_t line_min, uint16_t line_max)
+{
+  char buf[LINE_BUF_SIZE];
+  int show_lineno = 1, found_newline = 0, is_printed = 0;
+
+  if (file->fp == NULL) {
+    return;
+  }
+
+  while (fgets(buf, sizeof(buf), file->fp) != NULL) {
+    found_newline = remove_newlines(buf, file->fp);
+
+    if (line_min <= file->lineno) {
+      if (show_lineno) {
+        printf("%-8d", file->lineno);
+      }
+      show_lineno = found_newline;
+      printf(found_newline ? "%s\n" : "%s", buf);
+      is_printed = 1;
+    }
+
+    if (found_newline) {
+      if (line_max < ++file->lineno) {
+        break;
+      }
+    }
+  }
+
+  if (is_printed && !found_newline) {
+    printf("\n");
+  }
+}
+
+char*
+mrb_debug_get_source(mrb_state *mrb, mrdb_state *mrdb, const char *srcpath, const char *filename)
+{
+  int i;
+  FILE *fp;
+  const char *search_path[3];
+  char *path = NULL;
+  const char *srcname = strrchr(filename, '/');
+
+  if (srcname) srcname++;
+  else srcname = filename;
+
+  search_path[0] = srcpath;
+  search_path[1] = dirname(mrb, mrb_debug_get_filename(mrb, mrdb->dbg->irep, 0));
+  search_path[2] = ".";
+
+  for (i = 0; i < 3; i++) {
+    if (search_path[i] == NULL) {
+      continue;
+    }
+
+    if ((path = build_path(mrb, search_path[i], srcname)) == NULL) {
+      continue;
+    }
+
+    if ((fp = fopen(path, "rb")) == NULL) {
+      mrb_free(mrb, path);
+      path = NULL;
+      continue;
+    }
+    fclose(fp);
+    break;
+  }
+
+  mrb_free(mrb, (void *)search_path[1]);
+
+  return path;
+}
+
+int32_t
+mrb_debug_list(mrb_state *mrb, mrb_debug_context *dbg, char *filename, uint16_t line_min, uint16_t line_max)
+{
+  char *ext;
+  source_file *file;
+
+  if (mrb == NULL || dbg == NULL || filename == NULL) {
+    return MRB_DEBUG_INVALID_ARGUMENT;
+  }
+
+  ext = strrchr(filename, '.');
+
+  if (ext == NULL || strcmp(ext, ".rb")) {
+    printf("List command only supports .rb file.\n");
+    return MRB_DEBUG_INVALID_ARGUMENT;
+  }
+
+  if (line_min > line_max) {
+    return MRB_DEBUG_INVALID_ARGUMENT;
+  }
+
+  if ((file = source_file_new(mrb, dbg, filename)) != NULL) {
+    show_lines(file, line_min, line_max);
+    source_file_free(mrb, file);
+    return MRB_DEBUG_OK;
+  }
+  else {
+    printf("Invalid source file named %s.\n", filename);
+    return MRB_DEBUG_INVALID_ARGUMENT;
+  }
+}
Index: EcnlProtoTool/trunk/prototool/src/apilist.h
===================================================================
--- EcnlProtoTool/trunk/prototool/src/apilist.h	(revision 439)
+++ EcnlProtoTool/trunk/prototool/src/apilist.h	(revision 439)
@@ -0,0 +1,14 @@
+/*
+ * apilist.h
+ */
+
+#ifndef APILIST_H_
+#define APILIST_H_
+
+#include <mruby.h>
+#include "mrdb.h"
+
+int32_t mrb_debug_list(mrb_state *, mrb_debug_context *, char *, uint16_t, uint16_t);
+char* mrb_debug_get_source(mrb_state *, mrdb_state *, const char *, const char *);
+
+#endif /* APILIST_H_ */
Index: EcnlProtoTool/trunk/prototool/src/apiprint.c
===================================================================
--- EcnlProtoTool/trunk/prototool/src/apiprint.c	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/apiprint.c	(revision 439)
@@ -4,13 +4,12 @@
 */
 
-#include <stdlib.h>
-
+#include <string.h>
 #include "mrdb.h"
-#include "mruby/value.h"
-#include "mruby/class.h"
-#include "mruby/compile.h"
-#include "mruby/error.h"
-#include "mruby/numeric.h"
-#include "mruby/string.h"
+#include <mruby/value.h>
+#include <mruby/class.h>
+#include <mruby/compile.h>
+#include <mruby/error.h>
+#include <mruby/numeric.h>
+#include <mruby/string.h>
 #include "apiprint.h"
 
@@ -18,62 +17,67 @@
 mrdb_check_syntax(mrb_state *mrb, mrb_debug_context *dbg, const char *expr, size_t len)
 {
-	mrbc_context *c;
+  mrbc_context *c;
 
-	c = mrbc_context_new(mrb);
-	c->no_exec = TRUE;
-	c->capture_errors = TRUE;
-	c->filename = (char*)dbg->prvfile;
-	c->lineno = dbg->prvline;
+  c = mrbc_context_new(mrb);
+  c->no_exec = TRUE;
+  c->capture_errors = TRUE;
+  mrbc_filename(mrb, c, (const char*)dbg->prvfile);
+  c->lineno = dbg->prvline;
 
-	/* Load program */
-	mrb_load_nstring_cxt(mrb, expr, len, c);
+  /* Load program */
+  mrb_load_nstring_cxt(mrb, expr, len, c);
 
-	mrbc_context_free(mrb, c);
+  mrbc_context_free(mrb, c);
 }
 
 mrb_value
-mrb_debug_eval(mrb_state *mrb, mrb_debug_context *dbg, const char *expr, size_t len, mrb_bool *exc)
+mrb_debug_eval(mrb_state *mrb, mrb_debug_context *dbg, const char *expr, size_t len, mrb_bool *exc, int direct_eval)
 {
-	void(*tmp)(struct mrb_state *, struct mrb_irep *, mrb_code *, mrb_value *);
-	mrb_value ruby_code;
-	mrb_value s;
-	mrb_value v;
-	mrb_value recv;
+  void (*tmp)(struct mrb_state *, struct mrb_irep *, const mrb_code *, mrb_value *);
+  mrb_value ruby_code;
+  mrb_value s;
+  mrb_value v;
+  mrb_value recv;
 
-	/* disable code_fetch_hook */
-	tmp = mrb->code_fetch_hook;
-	mrb->code_fetch_hook = NULL;
+  /* disable code_fetch_hook */
+  tmp = mrb->code_fetch_hook;
+  mrb->code_fetch_hook = NULL;
 
-	mrdb_check_syntax(mrb, dbg, expr, len);
-	if (mrb->exc) {
-		v = mrb_obj_value(mrb->exc);
-		mrb->exc = 0;
-	}
-	else {
-		/*
-		 * begin
-		 *   expr
-		 * rescue => e
-		 *   e
-		 * end
-		 */
-		ruby_code = mrb_str_new_lit(mrb, "begin\n");
-		ruby_code = mrb_str_cat(mrb, ruby_code, expr, len);
-		ruby_code = mrb_str_cat_lit(mrb, ruby_code, "\nrescue => e\ne\nend");
+  mrdb_check_syntax(mrb, dbg, expr, len);
+  if (mrb->exc) {
+    v = mrb_obj_value(mrb->exc);
+    mrb->exc = 0;
+  }
+  else if (direct_eval) {
+    recv = dbg->regs[0];
 
-		recv = dbg->regs[0];
+    v = mrb_funcall(mrb, recv, expr, 0);
+  }
+  else {
+    /*
+     * begin
+     *   expr
+     * rescue => e
+     *   e
+     * end
+     */
+    ruby_code = mrb_str_new_lit(mrb, "begin\n");
+    ruby_code = mrb_str_cat(mrb, ruby_code, expr, len);
+    ruby_code = mrb_str_cat_lit(mrb, ruby_code, "\nrescue => e\ne\nend");
 
-		v = mrb_funcall(mrb, recv, "instance_eval", 1, ruby_code);
-	}
+    recv = dbg->regs[0];
 
-	if (exc) {
-		*exc = mrb_obj_is_kind_of(mrb, v, mrb->eException_class);
-	}
+    v =  mrb_funcall(mrb, recv, "instance_eval", 1, ruby_code);
+  }
 
-	s = mrb_funcall(mrb, v, "inspect", 0);
+  if (exc) {
+    *exc = mrb_obj_is_kind_of(mrb, v, mrb->eException_class);
+  }
 
-	/* enable code_fetch_hook */
-	mrb->code_fetch_hook = tmp;
+  s = mrb_inspect(mrb, v);
 
-	return s;
+  /* enable code_fetch_hook */
+  mrb->code_fetch_hook = tmp;
+
+  return s;
 }
Index: EcnlProtoTool/trunk/prototool/src/apiprint.h
===================================================================
--- EcnlProtoTool/trunk/prototool/src/apiprint.h	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/apiprint.h	(revision 439)
@@ -6,8 +6,8 @@
 #define APIPRINT_H_
 
-#include "mruby.h"
+#include <mruby.h>
 #include "mrdb.h"
 
-mrb_value mrb_debug_eval(mrb_state*, mrb_debug_context*, const char*, size_t, mrb_bool*);
+mrb_value mrb_debug_eval(mrb_state*, mrb_debug_context*, const char*, size_t, mrb_bool*, int);
 
 #endif /* APIPRINT_H_ */
Index: EcnlProtoTool/trunk/prototool/src/cmdbreak.c
===================================================================
--- EcnlProtoTool/trunk/prototool/src/cmdbreak.c	(revision 438)
+++ EcnlProtoTool/trunk/prototool/src/cmdbreak.c	(revision 439)
@@ -4,11 +4,10 @@
 */
 
-#include <stdlib.h>
+#include <ctype.h>
 #include <string.h>
-
-#include "mruby.h"
-#include "mruby/dump.h"
-#include "mruby/debug.h"
-#include "mruby/string.h"
+#include <mruby.h>
+#include <mruby/dump.h>
+#include <mruby/debug.h>
+#include <mruby/string.h>
 #include "mrdb.h"
 #include "mrdberror.h"
@@ -44,17 +43,17 @@
 #define BPNO_LETTER_NUM 9
 
-typedef int32_t(*all_command_func)(mrb_state *, mrb_debug_context *);
-typedef int32_t(*select_command_func)(mrb_state *, mrb_debug_context *, uint32_t);
+typedef int32_t (*all_command_func)(mrb_state *, mrb_debug_context *);
+typedef int32_t (*select_command_func)(mrb_state *, mrb_debug_context *, uint32_t);
 
 static void
 print_api_common_error(int32_t error)
 {
-	switch (error) {
-	case MRB_DEBUG_INVALID_ARGUMENT:
-		puts(BREAK_ERR_MSG_INVALIDARG);
-		break;
-	default:
-		break;
-	}
+  switch(error) {
+    case MRB_DEBUG_INVALID_ARGUMENT:
+      puts(BREAK_ERR_MSG_INVALIDARG);
+      break;
+    default:
+      break;
+  }
 }
 
@@ -69,20 +68,20 @@
 parse_breakpoint_no(char* args)
 {
-	char* ps = args;
-	uint32_t l;
-
-	if ((*ps == '0') || (strlen(ps) >= BPNO_LETTER_NUM)) {
-		return 0;
-	}
-
-	while (!(ISBLANK(*ps) || ISCNTRL(*ps))) {
-		if (!ISDIGIT(*ps)) {
-			return 0;
-		}
-		ps++;
-	}
-
-	STRTOUL(l, args);
-	return l;
+  char* ps = args;
+  uint32_t l;
+
+  if ((*ps == '0')||(strlen(ps) >= BPNO_LETTER_NUM)) {
+    return 0;
+  }
+
+  while (!(ISBLANK(*ps)||ISCNTRL(*ps))) {
+    if (!ISDIGIT(*ps)) {
+      return 0;
+    }
+    ps++;
+  }
+
+  STRTOUL(l, args);
+  return l;
 }
 
@@ -90,12 +89,12 @@
 exe_set_command_all(mrb_state *mrb, mrdb_state *mrdb, all_command_func func)
 {
-	int32_t ret = MRB_DEBUG_OK;
-
-	if (mrdb->wcnt == 1) {
-		ret = func(mrb, mrdb->dbg);
-		print_api_common_error(ret);
-		return TRUE;
-	}
-	return FALSE;
+  int32_t ret = MRB_DEBUG_OK;
+
+  if (mrdb->wcnt == 1) {
+    ret = func(mrb, mrdb->dbg);
+    print_api_common_error(ret);
+    return TRUE;
+  }
+  return FALSE;
 }
 
@@ -103,24 +102,24 @@
 exe_set_command_select(mrb_state *mrb, mrdb_state *mrdb, select_command_func func)
 {
-	char* ps;
-	int32_t ret = MRB_DEBUG_OK;
-	int32_t bpno = 0;
-	int32_t i;
-
-	for (i = 1; i < mrdb->wcnt; i++) {
-		ps = mrdb->words[i];
-		bpno = parse_breakpoint_no(ps);
-		if (bpno == 0) {
-			printf(BREAK_ERR_MSG_INVALIDBPNO, ps);
-			break;
-		}
-		ret = func(mrb, mrdb->dbg, (uint32_t)bpno);
-		if (ret == MRB_DEBUG_BREAK_INVALID_NO) {
-			printf(BREAK_ERR_MSG_NOBPNO, bpno);
-		}
-		else if (ret != MRB_DEBUG_OK) {
-			print_api_common_error(ret);
-		}
-	}
+  char* ps;
+  int32_t ret = MRB_DEBUG_OK;
+  int32_t bpno = 0;
+  int32_t i;
+
+  for(i=1; i<mrdb->wcnt; i++) {
+    ps = mrdb->words[i];
+    bpno = parse_breakpoint_no(ps);
+    if (bpno == 0) {
+      printf(BREAK_ERR_MSG_INVALIDBPNO, ps);
+      break;
+    }
+    ret = func(mrb, mrdb->dbg, (uint32_t)bpno);
+    if (ret == MRB_DEBUG_BREAK_INVALID_NO) {
+      printf(BREAK_ERR_MSG_NOBPNO, bpno);
+    }
+    else if (ret != MRB_DEBUG_OK) {
+      print_api_common_error(ret);
+    }
+  }
 }
 
@@ -128,29 +127,29 @@
 check_bptype(char* args)
 {
-	char* ps = args;
-
-	if (ISBLANK(*ps) || ISCNTRL(*ps)) {
-		puts(BREAK_ERR_MSG_BLANK);
-		return MRB_DEBUG_BPTYPE_NONE;
-	}
-
-	if (!ISDIGIT(*ps)) {
-		return MRB_DEBUG_BPTYPE_METHOD;
-	}
-
-	while (!(ISBLANK(*ps) || ISCNTRL(*ps))) {
-		if (!ISDIGIT(*ps)) {
-			printf(BREAK_ERR_MSG_INVALIDSTR, args);
-			return MRB_DEBUG_BPTYPE_NONE;
-		}
-		ps++;
-	}
-
-	if ((*args == '0') || (strlen(args) >= LINENO_MAX_DIGIT)) {
-		puts(BREAK_ERR_MSG_RANGEOVER);
-		return MRB_DEBUG_BPTYPE_NONE;
-	}
-
-	return MRB_DEBUG_BPTYPE_LINE;
+  char* ps = args;
+
+  if (ISBLANK(*ps)||ISCNTRL(*ps)) {
+    puts(BREAK_ERR_MSG_BLANK);
+    return MRB_DEBUG_BPTYPE_NONE;
+  }
+
+  if (!ISDIGIT(*ps)) {
+    return MRB_DEBUG_BPTYPE_METHOD;
+  }
+
+  while (!(ISBLANK(*ps)||ISCNTRL(*ps))) {
+    if (!ISDIGIT(*ps)) {
+      printf(BREAK_ERR_MSG_INVALIDSTR, args);
+      return MRB_DEBUG_BPTYPE_NONE;
+    }
+    ps++;
+  }
+
+  if ((*args == '0')||(strlen(args) >= LINENO_MAX_DIGIT)) {
+    puts(BREAK_ERR_MSG_RANGEOVER);
+    return MRB_DEBUG_BPTYPE_NONE;
+  }
+
+  return MRB_DEBUG_BPTYPE_LINE;
 }
 
@@ -158,20 +157,20 @@
 print_breakpoint(mrb_debug_breakpoint *bp)
 {
-	const char* enable_letter[] = { BREAK_INFO_MSG_DISABLE, BREAK_INFO_MSG_ENABLE };
-
-	if (bp->type == MRB_DEBUG_BPTYPE_LINE) {
-		printf(BREAK_INFO_MSG_LINEBREAK,
-			bp->bpno, enable_letter[bp->enable], bp->point.linepoint.file, bp->point.linepoint.lineno);
-	}
-	else {
-		if (bp->point.methodpoint.class_name == NULL) {
-			printf(BREAK_INFO_MSG_METHODBREAK_NOCLASS,
-				bp->bpno, enable_letter[bp->enable], bp->point.methodpoint.method_name);
-		}
-		else {
-			printf(BREAK_INFO_MSG_METHODBREAK,
-				bp->bpno, enable_letter[bp->enable], bp->point.methodpoint.class_name, bp->point.methodpoint.method_name);
-		}
-	}
+  const char* enable_letter[] = {BREAK_INFO_MSG_DISABLE, BREAK_INFO_MSG_ENABLE};
+
+  if (bp->type == MRB_DEBUG_BPTYPE_LINE) {
+    printf(BREAK_INFO_MSG_LINEBREAK,
+      bp->bpno, enable_letter[bp->enable], bp->point.linepoint.file, bp->point.linepoint.lineno);
+  }
+  else {
+    if (bp->point.methodpoint.class_name == NULL) {
+      printf(BREAK_INFO_MSG_METHODBREAK_NOCLASS,
+        bp->bpno, enable_letter[bp->enable], bp->point.methodpoint.method_name);
+    }
+    else {
+      printf(BREAK_INFO_MSG_METHODBREAK,
+        bp->bpno, enable_letter[bp->enable], bp->point.methodpoint.class_name, bp->point.methodpoint.method_name);
+    }
+  }
 }
 
@@ -179,31 +178,31 @@
 info_break_all(mrb_state *mrb, mrdb_state *mrdb)
 {
-	int32_t bpnum = 0;
-	int32_t i = 0;
-	int32_t ret = MRB_DEBUG_OK;
-	mrb_debug_breakpoint *bp_list;
-
-	bpnum = mrb_debug_get_breaknum(mrb, mrdb->dbg);
-	if (bpnum < 0) {
-		print_api_common_error(bpnum);
-		return;
-	}
-	else if (bpnum == 0) {
-		puts(BREAK_ERR_MSG_NOBPNO_INFOALL);
-		return;
-	}
-	bp_list = (mrb_debug_breakpoint*)mrb_malloc(mrb, bpnum * sizeof(mrb_debug_breakpoint));
-
-	ret = mrb_debug_get_break_all(mrb, mrdb->dbg, (uint32_t)bpnum, bp_list);
-	if (ret < 0) {
-		print_api_common_error(ret);
-		return;
-	}
-	puts(BREAK_INFO_MSG_HEADER);
-	for (i = 0; i < bpnum; i++) {
-		print_breakpoint(&bp_list[i]);
-	}
-
-	mrb_free(mrb, bp_list);
+  int32_t bpnum = 0;
+  int32_t i = 0;
+  int32_t ret = MRB_DEBUG_OK;
+  mrb_debug_breakpoint *bp_list;
+
+  bpnum = mrb_debug_get_breaknum(mrb, mrdb->dbg);
+  if (bpnum < 0) {
+    print_api_common_error(bpnum);
+    return;
+  }
+  else if (bpnum == 0) {
+    puts(BREAK_ERR_MSG_NOBPNO_INFOALL);
+    return;
+  }
+  bp_list = (mrb_debug_breakpoint*)mrb_malloc(mrb, bpnum * sizeof(mrb_debug_breakpoint));
+
+  ret = mrb_debug_get_break_all(mrb, mrdb->dbg, (uint32_t)bpnum, bp_list);
+  if (ret < 0) {
+    print_api_common_error(ret);
+    return;
+  }
+  puts(BREAK_INFO_MSG_HEADER);
+  for(i = 0 ; i < bpnum ; i++) {
+    print_breakpoint(&bp_list[i]);
+  }
+
+  mrb_free(mrb, bp_list);
 }
 
@@ -211,114 +210,114 @@
 info_break_select(mrb_state *mrb, mrdb_state *mrdb)
 {
-	int32_t ret = MRB_DEBUG_OK;
-	int32_t bpno = 0;
-	char* ps = mrdb->command;
-	mrb_debug_breakpoint bp;
-	mrb_bool isFirst = TRUE;
-	int32_t i;
-
-	for (i = 2; i < mrdb->wcnt; i++) {
-		ps = mrdb->words[i];
-		bpno = parse_breakpoint_no(ps);
-		if (bpno == 0) {
-			puts(BREAK_ERR_MSG_INVALIDBPNO_INFO);
-			break;
-		}
-
-		ret = mrb_debug_get_break(mrb, mrdb->dbg, bpno, &bp);
-		if (ret == MRB_DEBUG_BREAK_INVALID_NO) {
-			printf(BREAK_ERR_MSG_NOBPNO_INFO, bpno);
-			break;
-		}
-		else if (ret != MRB_DEBUG_OK) {
-			print_api_common_error(ret);
-			break;
-		}
-		else if (isFirst == TRUE) {
-			isFirst = FALSE;
-			puts(BREAK_INFO_MSG_HEADER);
-		}
-		print_breakpoint(&bp);
-	}
+  int32_t ret = MRB_DEBUG_OK;
+  int32_t bpno = 0;
+  char* ps = mrdb->command;
+  mrb_debug_breakpoint bp;
+  mrb_bool isFirst = TRUE;
+  int32_t i;
+
+  for(i=2; i<mrdb->wcnt; i++) {
+    ps = mrdb->words[i];
+    bpno = parse_breakpoint_no(ps);
+    if (bpno == 0) {
+      puts(BREAK_ERR_MSG_INVALIDBPNO_INFO);
+      break;
+    }
+
+    ret = mrb_debug_get_break(mrb, mrdb->dbg, bpno, &bp);
+    if (ret == MRB_DEBUG_BREAK_INVALID_NO) {
+      printf(BREAK_ERR_MSG_NOBPNO_INFO, bpno);
+      break;
+    }
+    else if (ret != MRB_DEBUG_OK) {
+      print_api_common_error(ret);
+      break;
+    }
+    else if (isFirst == TRUE) {
+      isFirst = FALSE;
+      puts(BREAK_INFO_MSG_HEADER);
+    }
+    print_breakpoint(&bp);
+  }
 }
 
 mrb_debug_bptype
-parse_breakcommand(mrdb_state *mrdb, const char **file, uint32_t *line, char **cname, char **method)
-{
-	mrb_debug_context *dbg = mrdb->dbg;
-	char *args;
-	char *body;
-	mrb_debug_bptype type;
-	uint32_t l;
-
-	if (mrdb->wcnt <= 1) {
-		puts(BREAK_ERR_MSG_BLANK);
-		return MRB_DEBUG_BPTYPE_NONE;
-	}
-
-	args = mrdb->words[1];
-	if ((body = strrchr(args, ':')) == NULL) {
-		body = args;
-		type = check_bptype(body);
-	}
-	else {
-		if (body == args) {
-			printf(BREAK_ERR_MSG_INVALIDSTR, args);
-			return MRB_DEBUG_BPTYPE_NONE;
-		}
-		*body = '\0';
-		type = check_bptype(++body);
-	}
-
-	switch (type) {
-	case MRB_DEBUG_BPTYPE_LINE:
-		STRTOUL(l, body);
-		if (l <= 65535) {
-			*line = l;
-			*file = (body == args) ? mrb_debug_get_filename(dbg->irep, (uint32_t)(dbg->pc - dbg->irep->iseq)) : args;
-		}
-		else {
-			puts(BREAK_ERR_MSG_RANGEOVER);
-			type = MRB_DEBUG_BPTYPE_NONE;
-		}
-		break;
-	case MRB_DEBUG_BPTYPE_METHOD:
-		if (body == args) {
-			/* method only */
-			if (ISUPPER(*body) || ISLOWER(*body) || (*body == '_')) {
-				*method = body;
-				*cname = NULL;
-			}
-			else {
-				printf(BREAK_ERR_MSG_INVALIDMETHOD, args);
-				type = MRB_DEBUG_BPTYPE_NONE;
-			}
-		}
-		else {
-			if (ISUPPER(*args)) {
-				switch (*body) {
-				case '@': case '$': case '?': case '.': case ',': case ':':
-				case ';': case '#': case '\\': case '\'': case '\"':
-					printf(BREAK_ERR_MSG_INVALIDMETHOD, body);
-					type = MRB_DEBUG_BPTYPE_NONE;
-					break;
-				default:
-					*method = body;
-					*cname = args;
-					break;
-				}
-			}
-			else {
-				printf(BREAK_ERR_MSG_INVALIDCLASS, args);
-				type = MRB_DEBUG_BPTYPE_NONE;
-			}
-		}
-		break;
-	case MRB_DEBUG_BPTYPE_NONE:
-	default:
-		break;
-	}
-
-	return type;
+parse_breakcommand(mrb_state *mrb, mrdb_state *mrdb, const char **file, uint32_t *line, char **cname, char **method)
+{
+  mrb_debug_context *dbg = mrdb->dbg;
+  char *args;
+  char *body;
+  mrb_debug_bptype type;
+  uint32_t l;
+
+  if (mrdb->wcnt <= 1) {
+    puts(BREAK_ERR_MSG_BLANK);
+    return MRB_DEBUG_BPTYPE_NONE;
+  }
+
+  args = mrdb->words[1];
+  if ((body = strrchr(args, ':')) == NULL) {
+    body = args;
+    type = check_bptype(body);
+  }
+  else {
+    if (body == args) {
+      printf(BREAK_ERR_MSG_INVALIDSTR, args);
+      return MRB_DEBUG_BPTYPE_NONE;
+    }
+    *body = '\0';
+    type = check_bptype(++body);
+  }
+
+  switch(type) {
+    case MRB_DEBUG_BPTYPE_LINE:
+      STRTOUL(l, body);
+      if (l <= 65535) {
+        *line = l;
+        *file = (body == args)? mrb_debug_get_filename(mrb, dbg->irep, dbg->pc - dbg->irep->iseq): args;
+      }
+      else {
+        puts(BREAK_ERR_MSG_RANGEOVER);
+        type = MRB_DEBUG_BPTYPE_NONE;
+      }
+      break;
+    case MRB_DEBUG_BPTYPE_METHOD:
+      if (body == args) {
+        /* method only */
+        if (ISUPPER(*body)||ISLOWER(*body)||(*body == '_')) {
+          *method = body;
+          *cname = NULL;
+        }
+        else {
+          printf(BREAK_ERR_MSG_INVALIDMETHOD, args);
+          type = MRB_DEBUG_BPTYPE_NONE;
+        }
+      }
+      else {
+        if (ISUPPER(*args)) {
+          switch(*body) {
+            case '@': case '$': case '?': case '.': case ',': case ':':
+            case ';': case '#': case '\\': case '\'': case '\"':
+            printf(BREAK_ERR_MSG_INVALIDMETHOD, body);
+            type = MRB_DEBUG_BPTYPE_NONE;
+            break;
+          default:
+            *method = body;
+            *cname = args;
+            break;
+          }
+        }
+        else {
+          printf(BREAK_ERR_MSG_INVALIDCLASS, args);
+          type = MRB_DEBUG_BPTYPE_NONE;
+        }
+      }
+      break;
+    case MRB_DEBUG_BPTYPE_NONE:
+    default:
+      break;
+  }
+
+  return type;
 }
 
@@ -326,62 +325,62 @@
 dbgcmd_break(mrb_state *mrb, mrdb_state *mrdb)
 {
-	mrb_debug_bptype type;
-	mrb_debug_context *dbg = mrdb->dbg;
-	const char *file = NULL;
-	uint32_t line = 0;
-	char *cname = NULL;
-	char *method = NULL;
-	int32_t ret;
-
-	type = parse_breakcommand(mrdb, &file, &line, &cname, &method);
-	switch (type) {
-	case MRB_DEBUG_BPTYPE_LINE:
-		ret = mrb_debug_set_break_line(mrb, dbg, file, line);
-		break;
-	case MRB_DEBUG_BPTYPE_METHOD:
-		ret = mrb_debug_set_break_method(mrb, dbg, cname, method);
-		break;
-	case MRB_DEBUG_BPTYPE_NONE:
-	default:
-		return DBGST_PROMPT;
-	}
-
-	if (ret >= 0) {
-		if (type == MRB_DEBUG_BPTYPE_LINE) {
-			printf(BREAK_SET_MSG_LINE, ret, file, line);
-		}
-		else if ((type == MRB_DEBUG_BPTYPE_METHOD) && (cname == NULL)) {
-			printf(BREAK_SET_MSG_METHOD, ret, method);
-		}
-		else {
-			printf(BREAK_SET_MSG_CLASS_METHOD, ret, cname, method);
-		}
-	}
-	else {
-		switch (ret) {
-		case MRB_DEBUG_BREAK_INVALID_LINENO:
-			printf(BREAK_ERR_MSG_INVALIDLINENO, line, file);
-			break;
-		case MRB_DEBUG_BREAK_INVALID_FILE:
-			printf(BREAK_ERR_MSG_INVALIDFILE, file);
-			break;
-		case MRB_DEBUG_BREAK_NUM_OVER:
-			puts(BREAK_ERR_MSG_NUMOVER);
-			break;
-		case MRB_DEBUG_BREAK_NO_OVER:
-			puts(BREAK_ERR_MSG_NOOVER);
-			break;
-		case MRB_DEBUG_INVALID_ARGUMENT:
-			puts(BREAK_ERR_MSG_INVALIDARG);
-			break;
-		case MRB_DEBUG_NOBUF:
-			puts("T.B.D.");
-			break;
-		default:
-			break;
-		}
-	}
-
-	return DBGST_PROMPT;
+  mrb_debug_bptype type;
+  mrb_debug_context *dbg = mrdb->dbg;
+  const char *file = NULL;
+  uint32_t line = 0;
+  char *cname = NULL;
+  char *method = NULL;
+  int32_t ret;
+
+  type = parse_breakcommand(mrb, mrdb, &file, &line, &cname, &method);
+  switch (type) {
+    case MRB_DEBUG_BPTYPE_LINE:
+      ret = mrb_debug_set_break_line(mrb, dbg, file, line);
+      break;
+    case MRB_DEBUG_BPTYPE_METHOD:
+      ret = mrb_debug_set_break_method(mrb, dbg, cname, method);
+      break;
+    case MRB_DEBUG_BPTYPE_NONE:
+    default:
+      return DBGST_PROMPT;
+  }
+
+  if (ret >= 0) {
+    if (type == MRB_DEBUG_BPTYPE_LINE) {
+      printf(BREAK_SET_MSG_LINE, ret, file, line);
+    }
+    else if ((type == MRB_DEBUG_BPTYPE_METHOD)&&(cname == NULL)) {
+      printf(BREAK_SET_MSG_METHOD, ret, method);
+    }
+    else {
+      printf(BREAK_SET_MSG_CLASS_METHOD, ret, cname, method);
+    }
+  }
+  else {
+    switch (ret) {
+      case MRB_DEBUG_BREAK_INVALID_LINENO:
+        printf(BREAK_ERR_MSG_INVALIDLINENO, line, file);
+        break;
+      case MRB_DEBUG_BREAK_INVALID_FILE:
+        printf(BREAK_ERR_MSG_INVALIDFILE, file);
+        break;
+      case MRB_DEBUG_BREAK_NUM_OVER:
+        puts(BREAK_ERR_MSG_NUMOVER);
+        break;
+      case MRB_DEBUG_BREAK_NO_OVER:
+        puts(BREAK_ERR_MSG_NOOVER);
+        break;
+      case MRB_DEBUG_INVALID_ARGUMENT:
+        puts(BREAK_ERR_MSG_INVALIDARG);
+        break;
+      case MRB_DEBUG_NOBUF:
+        puts("T.B.D.");
+        break;
+      default:
+        break;
+    }
+  }
+
+  return DBGST_PROMPT;
 }
 
@@ -389,12 +388,12 @@
 dbgcmd_info_break(mrb_state *mrb, mrdb_state *mrdb)
 {
-	if (mrdb->wcnt == 2) {
-		info_break_all(mrb, mrdb);
-	}
-	else {
-		info_break_select(mrb, mrdb);
-	}
-
-	return DBGST_PROMPT;
+  if (mrdb->wcnt == 2) {
+    info_break_all(mrb, mrdb);
+  }
+  else {
+    info_break_select(mrb, mrdb);
+  }
+
+  return DBGST_PROMPT;
 }
 
@@ -402,12 +401,12 @@
 dbgcmd_delete(mrb_state *mrb, mrdb_state *mrdb)
 {
-	mrb_bool ret = FALSE;
-
-	ret = exe_set_command_all(mrb, mrdb, mrb_debug_delete_break_all);
-	if (ret != TRUE) {
-		exe_set_command_select(mrb, mrdb, mrb_debug_delete_break);
-	}
-
-	return DBGST_PROMPT;
+  mrb_bool ret = FALSE;
+
+  ret = exe_set_command_all(mrb, mrdb, mrb_debug_delete_break_all);
+  if (ret != TRUE) {
+    exe_set_command_select(mrb, mrdb, mrb_debug_delete_break);
+  }
+
+  return DBGST_PROMPT;
 }
 
@@ -415,12 +414,12 @@
 dbgcmd_enable(mrb_state *mrb, mrdb_state *mrdb)
 {
-	mrb_bool ret = FALSE;
-
-	ret = exe_set_command_all(mrb, mrdb, mrb_debug_enable_break_all);
-	if (ret != TRUE) {
-		exe_set_command_select(mrb, mrdb, mrb_debug_enable_break);
-	}
-
-	return DBGST_PROMPT;
+  mrb_bool ret = FALSE;
+
+  ret = exe_set_command_all(mrb, mrdb, mrb_debug_enable_break_all);
+  if (ret != TRUE) {
+    exe_set_command_select(mrb, mrdb, mrb_debug_enable_break);
+  }
+
+  return DBGST_PROMPT;
 }
 
@@ -428,10 +427,10 @@
 dbgcmd_disable(mrb_state *mrb, mrdb_state *mrdb)
 {
-	mrb_bool ret = FALSE;
-
-	ret = exe_set_command_all(mrb, mrdb, mrb_debug_disable_break_all);
-	if (ret != TRUE) {
-		exe_set_command_select(mrb, mrdb, mrb_debug_disable_break);
-	}
-	return DBGST_PROMPT;
-}
+  mrb_bool ret = FALSE;
+
+  ret = exe_set_command_all(mrb, mrdb, mrb_debug_disable_break_all);
+  if (ret != TRUE) {
+    exe_set_command_select(mrb, mrdb, mrb_debug_disable_break);
+  }
+  return DBGST_PROMPT;
+}
